Blob


1 #!/bin/sh
2 #
3 # Copyright (c) 2019 Stefan Sperling <stsp@openbsd.org>
4 #
5 # Permission to use, copy, modify, and distribute this software for any
6 # purpose with or without fee is hereby granted, provided that the above
7 # copyright notice and this permission notice appear in all copies.
8 #
9 # THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES
10 # WITH REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF
11 # MERCHANTABILITY AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR
12 # ANY SPECIAL, DIRECT, INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
13 # WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN
14 # ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF
15 # OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
17 . ./common.sh
19 test_commit_basic() {
20 local testroot=`test_init commit_basic`
22 got checkout $testroot/repo $testroot/wt > /dev/null
23 ret=$?
24 if [ $ret -ne 0 ]; then
25 test_done "$testroot" "$ret"
26 return 1
27 fi
29 echo "modified alpha" > $testroot/wt/alpha
30 (cd $testroot/wt && got rm beta >/dev/null)
31 echo "new file" > $testroot/wt/new
32 (cd $testroot/wt && got add new >/dev/null)
34 (cd $testroot/wt && got commit -m 'test commit_basic' > $testroot/stdout)
36 local head_rev=`git_show_head $testroot/repo`
37 echo "A new" > $testroot/stdout.expected
38 echo "M alpha" >> $testroot/stdout.expected
39 echo "D beta" >> $testroot/stdout.expected
40 echo "Created commit $head_rev" >> $testroot/stdout.expected
42 cmp -s $testroot/stdout.expected $testroot/stdout
43 ret=$?
44 if [ $ret -ne 0 ]; then
45 diff -u $testroot/stdout.expected $testroot/stdout
46 fi
47 test_done "$testroot" "$ret"
48 }
50 test_commit_new_subdir() {
51 local testroot=`test_init commit_new_subdir`
53 got checkout $testroot/repo $testroot/wt > /dev/null
54 ret=$?
55 if [ $ret -ne 0 ]; then
56 test_done "$testroot" "$ret"
57 return 1
58 fi
60 mkdir -p $testroot/wt/d
61 echo "new file" > $testroot/wt/d/new
62 echo "another new file" > $testroot/wt/d/new2
63 (cd $testroot/wt && got add d/new >/dev/null)
64 (cd $testroot/wt && got add d/new2 >/dev/null)
66 (cd $testroot/wt && \
67 got commit -m 'test commit_new_subdir' > $testroot/stdout)
69 local head_rev=`git_show_head $testroot/repo`
70 echo "A d/new" > $testroot/stdout.expected
71 echo "A d/new2" >> $testroot/stdout.expected
72 echo "Created commit $head_rev" >> $testroot/stdout.expected
74 cmp -s $testroot/stdout.expected $testroot/stdout
75 ret=$?
76 if [ $ret -ne 0 ]; then
77 diff -u $testroot/stdout.expected $testroot/stdout
78 fi
79 test_done "$testroot" "$ret"
80 }
82 test_commit_subdir() {
83 local testroot=`test_init commit_subdir`
85 got checkout $testroot/repo $testroot/wt > /dev/null
86 ret=$?
87 if [ $ret -ne 0 ]; then
88 test_done "$testroot" "$ret"
89 return 1
90 fi
92 echo "modified alpha" > $testroot/wt/alpha
93 echo "modified zeta" > $testroot/wt/epsilon/zeta
95 (cd $testroot/wt && \
96 got commit -m 'test commit_subdir' epsilon > $testroot/stdout)
98 local head_rev=`git_show_head $testroot/repo`
99 echo "M epsilon/zeta" >> $testroot/stdout.expected
100 echo "Created commit $head_rev" >> $testroot/stdout.expected
102 cmp -s $testroot/stdout.expected $testroot/stdout
103 ret=$?
104 if [ $ret -ne 0 ]; then
105 diff -u $testroot/stdout.expected $testroot/stdout
106 fi
107 test_done "$testroot" "$ret"
110 test_commit_single_file() {
111 local testroot=`test_init commit_single_file`
113 got checkout $testroot/repo $testroot/wt > /dev/null
114 ret=$?
115 if [ $ret -ne 0 ]; then
116 test_done "$testroot" "$ret"
117 return 1
118 fi
120 echo "modified alpha" > $testroot/wt/alpha
121 echo "modified zeta" > $testroot/wt/epsilon/zeta
123 (cd $testroot/wt && got commit -m 'changed zeta' epsilon/zeta \
124 > $testroot/stdout)
126 local head_rev=`git_show_head $testroot/repo`
127 echo "M epsilon/zeta" >> $testroot/stdout.expected
128 echo "Created commit $head_rev" >> $testroot/stdout.expected
130 cmp -s $testroot/stdout.expected $testroot/stdout
131 ret=$?
132 if [ $ret -ne 0 ]; then
133 diff -u $testroot/stdout.expected $testroot/stdout
134 fi
135 test_done "$testroot" "$ret"
138 test_commit_out_of_date() {
139 local testroot=`test_init commit_out_of_date`
140 local first_commit=`git_show_head $testroot/repo`
142 got checkout $testroot/repo $testroot/wt > /dev/null
143 ret=$?
144 if [ $ret -ne 0 ]; then
145 test_done "$testroot" "$ret"
146 return 1
147 fi
149 echo "modified alpha" > $testroot/repo/alpha
150 git_commit $testroot/repo -m "modified alpha"
152 echo "modified alpha" > $testroot/wt/alpha
154 (cd $testroot/wt && got commit -m 'test commit_out_of_date' \
155 > $testroot/stdout 2> $testroot/stderr)
157 echo -n > $testroot/stdout.expected
158 echo "got: work tree must be updated before these" \
159 "changes can be committed" > $testroot/stderr.expected
161 cmp -s $testroot/stdout.expected $testroot/stdout
162 ret=$?
163 if [ $ret -ne 0 ]; then
164 diff -u $testroot/stdout.expected $testroot/stdout
165 test_done "$testroot" "$ret"
166 return 1
167 fi
169 cmp -s $testroot/stderr.expected $testroot/stderr
170 ret=$?
171 if [ $ret -ne 0 ]; then
172 diff -u $testroot/stderr.expected $testroot/stderr
173 test_done "$testroot" "$ret"
174 return 1
175 fi
177 echo "alpha" > $testroot/repo/alpha
178 git_commit $testroot/repo -m "reset alpha contents"
179 (cd $testroot/wt && got update -c $first_commit > /dev/null)
181 echo "modified alpha" > $testroot/wt/alpha
183 (cd $testroot/wt && got commit -m 'changed alpha ' > $testroot/stdout)
184 ret=$?
185 if [ $ret -ne 0 ]; then
186 echo "commit failed unexpectedly" >&2
187 test_done "$testroot" "1"
188 return 1
189 fi
191 local head_rev=`git_show_head $testroot/repo`
192 echo "M alpha" > $testroot/stdout.expected
193 echo "Created commit $head_rev" >> $testroot/stdout.expected
194 cmp -s $testroot/stdout.expected $testroot/stdout
195 ret=$?
196 if [ $ret -ne 0 ]; then
197 diff -u $testroot/stdout.expected $testroot/stdout
198 fi
199 test_done "$testroot" "$ret"
202 test_commit_added_subdirs() {
203 local testroot=`test_init commit_added_subdirs`
205 got checkout $testroot/repo $testroot/wt > /dev/null
206 ret=$?
207 if [ $ret -ne 0 ]; then
208 test_done "$testroot" "$ret"
209 return 1
210 fi
212 mkdir -p $testroot/wt/d
213 echo "new file" > $testroot/wt/d/new
214 echo "new file 2" > $testroot/wt/d/new2
215 mkdir -p $testroot/wt/d/f
216 echo "new file 3" > $testroot/wt/d/f/new3
217 mkdir -p $testroot/wt/d/f/g
218 echo "new file 4" > $testroot/wt/d/f/g/new4
220 (cd $testroot/wt && got add $testroot/wt/*/new* \
221 $testroot/wt/*/*/new* $testroot/wt/*/*/*/new* > /dev/null)
223 (cd $testroot/wt && got commit -m 'test commit_added_subdirs' \
224 > $testroot/stdout 2> $testroot/stderr)
226 local head_rev=`git_show_head $testroot/repo`
227 echo "A d/f/g/new4" > $testroot/stdout.expected
228 echo "A d/f/new3" >> $testroot/stdout.expected
229 echo "A d/new" >> $testroot/stdout.expected
230 echo "A d/new2" >> $testroot/stdout.expected
231 echo "Created commit $head_rev" >> $testroot/stdout.expected
233 cmp -s $testroot/stdout.expected $testroot/stdout
234 ret=$?
235 if [ $ret -ne 0 ]; then
236 diff -u $testroot/stdout.expected $testroot/stdout
237 fi
238 test_done "$testroot" "$ret"
241 test_commit_deleted_subdirs() {
242 local testroot=`test_init commit_deleted_subdirs`
244 got checkout $testroot/repo $testroot/wt > /dev/null
245 ret=$?
246 if [ $ret -ne 0 ]; then
247 test_done "$testroot" "$ret"
248 return 1
249 fi
251 (cd $testroot/wt && \
252 got rm -R $testroot/wt/epsilon $testroot/wt/gamma >/dev/null)
254 (cd $testroot/wt && got commit -m 'test commit_deleted_subdirs' \
255 > $testroot/stdout 2> $testroot/stderr)
257 local head_rev=`git_show_head $testroot/repo`
258 echo "D epsilon/zeta" > $testroot/stdout.expected
259 echo "D gamma/delta" >> $testroot/stdout.expected
260 echo "Created commit $head_rev" >> $testroot/stdout.expected
262 cmp -s $testroot/stdout.expected $testroot/stdout
263 ret=$?
264 if [ $ret -ne 0 ]; then
265 diff -u $testroot/stdout.expected $testroot/stdout
266 test_done "$testroot" "$ret"
267 return 1
268 fi
270 got tree -r $testroot/repo > $testroot/stdout
272 echo "alpha" > $testroot/stdout.expected
273 echo "beta" >> $testroot/stdout.expected
275 cmp -s $testroot/stdout.expected $testroot/stdout
276 ret=$?
277 if [ $ret -ne 0 ]; then
278 diff -u $testroot/stdout.expected $testroot/stdout
279 fi
280 test_done "$testroot" "$ret"
283 test_commit_rejects_conflicted_file() {
284 local testroot=`test_init commit_rejects_conflicted_file`
286 local initial_rev=`git_show_head $testroot/repo`
288 got checkout $testroot/repo $testroot/wt > /dev/null
289 ret=$?
290 if [ $ret -ne 0 ]; then
291 test_done "$testroot" "$ret"
292 return 1
293 fi
295 echo "modified alpha" > $testroot/wt/alpha
296 (cd $testroot/wt && got commit -m "modified alpha" >/dev/null)
297 local commit_id1=`git_show_head $testroot/repo`
299 (cd $testroot/wt && got update -c $initial_rev > /dev/null)
301 echo "modified alpha, too" > $testroot/wt/alpha
303 echo "C alpha" > $testroot/stdout.expected
304 echo -n "Updated to refs/heads/master: " >> $testroot/stdout.expected
305 git_show_head $testroot/repo >> $testroot/stdout.expected
306 echo >> $testroot/stdout.expected
307 echo "Files with new merge conflicts: 1" >> $testroot/stdout.expected
309 (cd $testroot/wt && got update > $testroot/stdout)
311 cmp -s $testroot/stdout.expected $testroot/stdout
312 ret=$?
313 if [ $ret -ne 0 ]; then
314 diff -u $testroot/stdout.expected $testroot/stdout
315 test_done "$testroot" "$ret"
316 return 1
317 fi
319 (cd $testroot/wt && got commit -m 'commit it' > $testroot/stdout \
320 2> $testroot/stderr)
321 ret=$?
322 if [ $ret -eq 0 ]; then
323 echo "got commit succeeded unexpectedly"
324 test_done "$testroot" "$ret"
325 return 1
326 fi
328 echo "C alpha" > $testroot/stdout.expected
329 echo "got: cannot commit file in conflicted status" \
330 > $testroot/stderr.expected
332 cmp -s $testroot/stdout.expected $testroot/stdout
333 ret=$?
334 if [ $ret -ne 0 ]; then
335 diff -u $testroot/stdout.expected $testroot/stdout
336 test_done "$testroot" "$ret"
337 return 1
338 fi
339 cmp -s $testroot/stderr.expected $testroot/stderr
340 ret=$?
341 if [ $ret -ne 0 ]; then
342 diff -u $testroot/stderr.expected $testroot/stderr
343 test_done "$testroot" "$ret"
344 return 1
345 fi
347 (cd $testroot/wt && got commit -C -m 'commit it' > $testroot/stdout \
348 2> $testroot/stderr)
349 ret=$?
350 if [ $ret -ne 0 ]; then
351 echo "got commit failed unexpectedly"
352 test_done "$testroot" "$ret"
353 return 1
354 fi
356 # make sure the conflicted commit produces a diff
357 local conflict_commit=`git_show_head $testroot/repo`
358 local blob_minus=`got tree -r $testroot/repo -c $commit_id1 -i | \
359 grep 'alpha$' | cut -d' ' -f1`
360 local blob_plus=`got tree -r $testroot/repo -c $conflict_commit -i | \
361 grep 'alpha$' | cut -d' ' -f1`
363 echo -n > $testroot/stderr.expected
364 cmp -s $testroot/stderr.expected $testroot/stderr
365 ret=$?
366 if [ $ret -ne 0 ]; then
367 diff -u $testroot/stderr.expected $testroot/stderr
368 test_done "$testroot" "$ret"
369 return 1
370 fi
372 (cd $testroot/wt && got diff -c master > $testroot/stdout)
374 echo -n > $testroot/stdout.expected
375 cat > $testroot/stdout.expected <<EOF
376 diff $commit_id1 refs/heads/master
377 commit - $commit_id1
378 commit + $conflict_commit
379 blob - $blob_minus
380 blob + $blob_plus
381 --- alpha
382 +++ alpha
383 @@ -1 +1,7 @@
384 +<<<<<<< merged change: commit $commit_id1
385 modified alpha
386 +||||||| 3-way merge base: commit $initial_rev
387 +alpha
388 +=======
389 +modified alpha, too
390 +>>>>>>>
391 EOF
393 cmp -s $testroot/stdout.expected $testroot/stdout
394 ret=$?
395 if [ $ret -ne 0 ]; then
396 diff -u $testroot/stdout.expected $testroot/stdout
397 test_done "$testroot" "$ret"
398 return 1
399 fi
401 (cd $testroot/wt && got status > $testroot/stdout)
403 echo -n > $testroot/stdout.expected
404 cmp -s $testroot/stdout.expected $testroot/stdout
405 ret=$?
406 if [ $ret -ne 0 ]; then
407 diff -u $testroot/stdout.expected $testroot/stdout
408 fi
409 test_done "$testroot" "$ret"
412 test_commit_single_file_multiple() {
413 local testroot=`test_init commit_single_file_multiple`
415 got checkout $testroot/repo $testroot/wt > /dev/null
416 ret=$?
417 if [ $ret -ne 0 ]; then
418 test_done "$testroot" "$ret"
419 return 1
420 fi
422 for i in 1 2 3 4; do
423 echo "modified alpha" >> $testroot/wt/alpha
425 (cd $testroot/wt && \
426 got commit -m "changed alpha" > $testroot/stdout)
428 local head_rev=`git_show_head $testroot/repo`
429 echo "M alpha" > $testroot/stdout.expected
430 echo "Created commit $head_rev" >> $testroot/stdout.expected
432 cmp -s $testroot/stdout.expected $testroot/stdout
433 ret=$?
434 if [ $ret -ne 0 ]; then
435 diff -u $testroot/stdout.expected $testroot/stdout
436 test_done "$testroot" "$ret"
437 return 1
438 fi
439 done
441 test_done "$testroot" "0"
444 test_commit_added_and_modified_in_same_dir() {
445 local testroot=`test_init commit_added_and_modified_in_same_dir`
447 got checkout $testroot/repo $testroot/wt > /dev/null
448 ret=$?
449 if [ $ret -ne 0 ]; then
450 test_done "$testroot" "$ret"
451 return 1
452 fi
454 echo "modified zeta" > $testroot/wt/epsilon/zeta
455 echo "new file" > $testroot/wt/epsilon/new
456 (cd $testroot/wt && got add epsilon/new >/dev/null)
458 (cd $testroot/wt && got commit \
459 -m 'added and modified in same dir' > $testroot/stdout \
460 2> $testroot/stderr)
462 local head_rev=`git_show_head $testroot/repo`
463 echo "A epsilon/new" > $testroot/stdout.expected
464 echo "M epsilon/zeta" >> $testroot/stdout.expected
465 echo "Created commit $head_rev" >> $testroot/stdout.expected
467 cmp -s $testroot/stdout.expected $testroot/stdout
468 ret=$?
469 if [ $ret -ne 0 ]; then
470 diff -u $testroot/stdout.expected $testroot/stdout
471 fi
472 test_done "$testroot" "$ret"
475 test_commit_path_prefix() {
476 local testroot=`test_init commit_path_prefix`
477 local commit1=`git_show_head $testroot/repo`
479 got checkout -p gamma $testroot/repo $testroot/wt > /dev/null
480 ret=$?
481 if [ $ret -ne 0 ]; then
482 test_done "$testroot" "$ret"
483 return 1
484 fi
486 echo "modified delta" > $testroot/wt/delta
488 (cd $testroot/wt && got commit -m 'changed gamma/delta' > $testroot/stdout)
490 local commit2=`git_show_head $testroot/repo`
491 echo "M delta" > $testroot/stdout.expected
492 echo "Created commit $commit2" >> $testroot/stdout.expected
494 cmp -s $testroot/stdout.expected $testroot/stdout
495 ret=$?
496 if [ $ret -ne 0 ]; then
497 diff -u $testroot/stdout.expected $testroot/stdout
498 test_done "$testroot" "$ret"
499 return 1
500 fi
502 echo "diff $commit1 $commit2" > $testroot/stdout.expected
503 echo "commit - $commit1" >> $testroot/stdout.expected
504 echo "commit + $commit2" >> $testroot/stdout.expected
505 echo -n 'blob - ' >> $testroot/stdout.expected
506 got tree -r $testroot/repo -c $commit1 -i gamma | grep 'delta$' \
507 | cut -d' ' -f 1 >> $testroot/stdout.expected
508 echo -n 'blob + ' >> $testroot/stdout.expected
509 got tree -r $testroot/repo -c $commit2 -i gamma | grep 'delta$' | \
510 cut -d' ' -f 1 >> $testroot/stdout.expected
511 echo '--- gamma/delta' >> $testroot/stdout.expected
512 echo '+++ gamma/delta' >> $testroot/stdout.expected
513 echo '@@ -1 +1 @@' >> $testroot/stdout.expected
514 echo '-delta' >> $testroot/stdout.expected
515 echo '+modified delta' >> $testroot/stdout.expected
517 got diff -r $testroot/repo $commit1 $commit2 > $testroot/stdout
518 cmp -s $testroot/stdout.expected $testroot/stdout
519 ret=$?
520 if [ $ret -ne 0 ]; then
521 diff -u $testroot/stdout.expected $testroot/stdout
522 test_done "$testroot" "$ret"
523 return 1
524 fi
526 (cd $testroot/wt && got rm delta > /dev/null)
527 echo new > $testroot/wt/new
528 (cd $testroot/wt && got add new > /dev/null)
530 (cd $testroot/wt && got commit -m 'remove gamma/delta; add gamma/new' \
531 > $testroot/stdout)
533 local commit3=`git_show_head $testroot/repo`
534 echo "A new" > $testroot/stdout.expected
535 echo "D delta" >> $testroot/stdout.expected
536 echo "Created commit $commit3" >> $testroot/stdout.expected
538 cmp -s $testroot/stdout.expected $testroot/stdout
539 ret=$?
540 if [ $ret -ne 0 ]; then
541 diff -u $testroot/stdout.expected $testroot/stdout
542 test_done "$testroot" "$ret"
543 return 1
544 fi
546 echo "diff $commit2 $commit3" > $testroot/stdout.expected
547 echo "commit - $commit2" >> $testroot/stdout.expected
548 echo "commit + $commit3" >> $testroot/stdout.expected
549 echo -n 'blob - ' >> $testroot/stdout.expected
550 got tree -r $testroot/repo -c $commit2 -i gamma | grep 'delta$' \
551 | cut -d' ' -f 1 | sed -e 's/$/ (mode 644)/' \
552 >> $testroot/stdout.expected
553 echo 'blob + /dev/null' >> $testroot/stdout.expected
554 echo '--- gamma/delta' >> $testroot/stdout.expected
555 echo '+++ /dev/null' >> $testroot/stdout.expected
556 echo '@@ -1 +0,0 @@' >> $testroot/stdout.expected
557 echo '-modified delta' >> $testroot/stdout.expected
558 echo 'blob - /dev/null' >> $testroot/stdout.expected
559 echo -n 'blob + ' >> $testroot/stdout.expected
560 got tree -r $testroot/repo -c $commit3 -i gamma | grep 'new$' | \
561 cut -d' ' -f 1 | sed -e 's/$/ (mode 644)/' \
562 >> $testroot/stdout.expected
563 echo '--- /dev/null' >> $testroot/stdout.expected
564 echo '+++ gamma/new' >> $testroot/stdout.expected
565 echo '@@ -0,0 +1 @@' >> $testroot/stdout.expected
566 echo '+new' >> $testroot/stdout.expected
568 got diff -r $testroot/repo $commit2 $commit3 > $testroot/stdout
569 cmp -s $testroot/stdout.expected $testroot/stdout
570 ret=$?
571 if [ $ret -ne 0 ]; then
572 diff -u $testroot/stdout.expected $testroot/stdout
573 fi
574 test_done "$testroot" "$ret"
575 return "$ret"
578 test_commit_dir_path() {
579 local testroot=`test_init commit_dir_path`
581 got checkout $testroot/repo $testroot/wt > /dev/null
582 ret=$?
583 if [ $ret -ne 0 ]; then
584 test_done "$testroot" "$ret"
585 return 1
586 fi
588 echo "modified alpha" > $testroot/wt/alpha
589 echo "modified zeta" > $testroot/wt/epsilon/zeta
591 (cd $testroot/wt && got commit -m 'changed zeta' epsilon \
592 > $testroot/stdout)
594 local head_rev=`git_show_head $testroot/repo`
595 echo "M epsilon/zeta" >> $testroot/stdout.expected
596 echo "Created commit $head_rev" >> $testroot/stdout.expected
598 cmp -s $testroot/stdout.expected $testroot/stdout
599 ret=$?
600 if [ $ret -ne 0 ]; then
601 diff -u $testroot/stdout.expected $testroot/stdout
602 test_done "$testroot" "$ret"
603 return 1
604 fi
606 echo "M alpha" > $testroot/stdout.expected
607 (cd $testroot/wt && got status > $testroot/stdout)
608 cmp -s $testroot/stdout.expected $testroot/stdout
609 ret=$?
610 if [ $ret -ne 0 ]; then
611 diff -u $testroot/stdout.expected $testroot/stdout
612 fi
613 test_done "$testroot" "$ret"
616 test_commit_selected_paths() {
617 local testroot=`test_init commit_selected_paths`
619 got checkout $testroot/repo $testroot/wt > /dev/null
620 ret=$?
621 if [ $ret -ne 0 ]; then
622 test_done "$testroot" "$ret"
623 return 1
624 fi
626 echo "modified alpha" > $testroot/wt/alpha
627 echo "modified delta" > $testroot/wt/gamma/delta
628 echo "modified zeta" > $testroot/wt/epsilon/zeta
629 (cd $testroot/wt && got rm beta >/dev/null)
630 echo "new file" > $testroot/wt/new
631 (cd $testroot/wt && got add new >/dev/null)
633 (cd $testroot/wt && got commit -m 'many paths' nonexistent alpha \
634 > $testroot/stdout 2> $testroot/stderr)
635 ret=$?
636 if [ $ret -eq 0 ]; then
637 echo "commit succeeded unexpectedly" >&2
638 test_done "$testroot" "1"
639 return 1
640 fi
641 echo "got: nonexistent: bad path" > $testroot/stderr.expected
643 cmp -s $testroot/stderr.expected $testroot/stderr
644 ret=$?
645 if [ $ret -ne 0 ]; then
646 diff -u $testroot/stderr.expected $testroot/stderr
647 test_done "$testroot" "$ret"
648 return 1
649 fi
651 (cd $testroot/wt && got commit -m 'many paths' \
652 beta new gamma > $testroot/stdout)
654 local head_rev=`git_show_head $testroot/repo`
655 echo "A new" > $testroot/stdout.expected
656 echo "D beta" >> $testroot/stdout.expected
657 echo "M gamma/delta" >> $testroot/stdout.expected
658 echo "Created commit $head_rev" >> $testroot/stdout.expected
660 cmp -s $testroot/stdout.expected $testroot/stdout
661 ret=$?
662 if [ $ret -ne 0 ]; then
663 diff -u $testroot/stdout.expected $testroot/stdout
664 fi
665 test_done "$testroot" "$ret"
668 test_commit_outside_refs_heads() {
669 local testroot=`test_init commit_outside_refs_heads`
671 got ref -r $testroot/repo -c master refs/remotes/origin/master
673 got checkout -b refs/remotes/origin/master \
674 $testroot/repo $testroot/wt > /dev/null
675 ret=$?
676 if [ $ret -ne 0 ]; then
677 test_done "$testroot" "$ret"
678 return 1
679 fi
681 echo "modified alpha" > $testroot/wt/alpha
683 (cd $testroot/wt && got commit -m 'change alpha' \
684 > $testroot/stdout 2> $testroot/stderr)
685 ret=$?
686 if [ $ret -eq 0 ]; then
687 echo "commit succeeded unexpectedly" >&2
688 test_done "$testroot" "1"
689 return 1
690 fi
692 echo -n > $testroot/stdout.expected
693 cmp -s $testroot/stdout.expected $testroot/stdout
694 ret=$?
695 if [ $ret -ne 0 ]; then
696 diff -u $testroot/stdout.expected $testroot/stdout
697 test_done "$testroot" "$ret"
698 return 1
699 fi
701 echo -n "got: will not commit to a branch outside the " \
702 > $testroot/stderr.expected
703 echo '"refs/heads/" reference namespace' \
704 >> $testroot/stderr.expected
705 cmp -s $testroot/stderr.expected $testroot/stderr
706 ret=$?
707 if [ $ret -ne 0 ]; then
708 diff -u $testroot/stderr.expected $testroot/stderr
709 fi
710 test_done "$testroot" "$ret"
713 test_commit_no_email() {
714 local testroot=`test_init commit_no_email`
715 local errmsg=""
717 errmsg="commit author's email address is required for"
718 errmsg="$errmsg compatibility with Git"
720 got checkout $testroot/repo $testroot/wt > /dev/null
721 ret=$?
722 if [ $ret -ne 0 ]; then
723 test_done "$testroot" "$ret"
724 return 1
725 fi
727 echo "modified alpha" > $testroot/wt/alpha
728 (cd $testroot/wt && env GOT_AUTHOR=":flan_hacker:" \
729 got commit -m 'test no email' > $testroot/stdout \
730 2> $testroot/stderr)
732 printf "got: :flan_hacker:: %s\n" "$errmsg" > $testroot/stderr.expected
733 cmp -s $testroot/stderr.expected $testroot/stderr
734 ret=$?
735 if [ $ret -ne 0 ]; then
736 diff -u $testroot/stderr.expected $testroot/stderr
737 test_done "$testroot" "$ret"
738 return 1
739 fi
741 echo -n > $testroot/stdout.expected
742 cmp -s $testroot/stdout.expected $testroot/stdout
743 ret=$?
744 if [ $ret -ne 0 ]; then
745 diff -u $testroot/stdout.expected $testroot/stdout
746 test_done "$testroot" $ret
747 return 1
748 fi
750 # try again with a newline inside the email
751 (cd $testroot/wt \
752 && FS=' ' env GOT_AUTHOR="$(printf "Flan <hack\ner>")" \
753 got commit -m 'test invalid email' > $testroot/stdout \
754 2> $testroot/stderr)
756 printf "got: Flan <hack\ner>: %s\n" "$errmsg" \
757 > $testroot/stderr.expected
758 cmp -s $testroot/stderr.expected $testroot/stderr
759 ret=$?
760 if [ $ret -ne 0 ]; then
761 diff -u $testroot/stderr.expected $testroot/stderr
762 test_done "$testroot" $ret
763 return 1
764 fi
766 echo -n > $testroot/stdout.expected
767 cmp -s $testroot/stdout.expected $testroot/stdout
768 ret=$?
769 if [ $ret -ne 0 ]; then
770 diff -u $testroot/stdout.expected $testroot/stdout
771 test_done "$testroot" $ret
772 return 1
773 fi
775 # try again with a < inside the email
776 (cd $testroot/wt && env GOT_AUTHOR="$(printf "Flan <ha<ker>")" \
777 got commit -m 'test invalid email' > $testroot/stdout \
778 2> $testroot/stderr)
780 printf "got: Flan <ha<ker>: %s\n" "$errmsg" > $testroot/stderr.expected
781 cmp -s $testroot/stderr.expected $testroot/stderr
782 ret=$?
783 if [ $ret -ne 0 ]; then
784 diff -u $testroot/stderr.expected $testroot/stderr
785 test_done "$testroot" $ret
786 return 1
787 fi
789 echo -n > $testroot/stdout.expected
790 cmp -s $testroot/stdout.expected $testroot/stdout
791 ret=$?
792 if [ $ret -ne 0 ]; then
793 diff -u $testroot/stdout.expected $testroot/stdout
794 fi
795 test_done "$testroot" $ret
798 test_commit_tree_entry_sorting() {
799 local testroot=`test_init commit_tree_entry_sorting`
801 got checkout $testroot/repo $testroot/wt > /dev/null
802 ret=$?
803 if [ $ret -ne 0 ]; then
804 test_done "$testroot" "$ret"
805 return 1
806 fi
808 # Git's index gets corrupted when tree entries are written in the
809 # order defined by got_path_cmp() rather than Git's own ordering.
810 # Create a new tree where a directory "got" and a file "got-version"
811 # would sort in the wrong order according to Git's opinion.
812 mkdir $testroot/wt/got
813 touch $testroot/wt/got/foo
814 echo foo > $testroot/wt/got-version
815 echo zzz > $testroot/wt/zzz
816 (cd $testroot/wt && got add got-version got/foo zzz > /dev/null)
818 (cd $testroot/wt && got commit -m 'test' > /dev/null)
820 # Let git-fsck verify the newly written tree to make sure Git is happy
821 (cd $testroot/repo && git fsck --strict \
822 > $testroot/fsck.stdout 2> $testroot/fsck.stderr)
823 ret=$?
824 test_done "$testroot" "$ret"
827 test_commit_cmdline_author() {
828 local testroot=`test_init commit_cmdline_author`
830 got checkout $testroot/repo $testroot/wt > /dev/null
831 ret=$?
832 if [ $ret -ne 0 ]; then
833 test_done "$testroot" $ret
834 return 1
835 fi
837 echo "modified alpha" > $testroot/wt/alpha
839 local author="Foo <foo@example.com>"
840 (cd $testroot/wt && got commit -A "$author" -m 'edit alpha') \
841 > /dev/null
842 ret=$?
843 if [ $ret -ne 0 ]; then
844 test_done "$testroot" $ret
845 return 1
846 fi
848 (cd $testroot/repo && got log -l1 | egrep '^(from|via):') \
849 > $testroot/stdout
850 ret=$?
851 if [ $ret -ne 0 ]; then
852 test_done "$testroot" $ret
853 return 1
854 fi
856 echo "from: $author" > $testroot/stdout.expected
857 echo "via: $GOT_AUTHOR" >> $testroot/stdout.expected
858 cmp -s $testroot/stdout.expected $testroot/stdout
859 ret=$?
860 if [ $ret -ne 0 ]; then
861 diff -u $testroot/stdout.expected $testroot/stdout
862 fi
863 test_done "$testroot" $ret
866 test_commit_gotconfig_author() {
867 local testroot=`test_init commit_gotconfig_author`
869 got checkout $testroot/repo $testroot/wt > /dev/null
870 ret=$?
871 if [ $ret -ne 0 ]; then
872 test_done "$testroot" "$ret"
873 return 1
874 fi
875 echo 'author "Flan Luck <flan_luck@openbsd.org>"' \
876 > $testroot/repo/.git/got.conf
878 echo "modified alpha" > $testroot/wt/alpha
879 (cd $testroot/wt && got commit -m 'test gotconfig author' > /dev/null)
880 ret=$?
881 if [ $ret -ne 0 ]; then
882 test_done "$testroot" "$ret"
883 return 1
884 fi
886 (cd $testroot/repo && got log -l1 | grep ^from: > $testroot/stdout)
887 ret=$?
888 if [ $ret -ne 0 ]; then
889 test_done "$testroot" "$ret"
890 return 1
891 fi
893 echo "from: Flan Luck <flan_luck@openbsd.org>" \
894 > $testroot/stdout.expected
895 cmp -s $testroot/stdout.expected $testroot/stdout
896 ret=$?
897 if [ $ret -ne 0 ]; then
898 diff -u $testroot/stdout.expected $testroot/stdout
899 fi
900 test_done "$testroot" "$ret"
903 test_commit_gotconfig_worktree_author() {
904 local testroot=`test_init commit_gotconfig_worktree_author`
906 got checkout $testroot/repo $testroot/wt > /dev/null
907 ret=$?
908 if [ $ret -ne 0 ]; then
909 test_done "$testroot" "$ret"
910 return 1
911 fi
912 echo 'author "Flan Luck <flan_luck@openbsd.org>"' \
913 > $testroot/repo/.git/got.conf
914 echo 'author "Flan Squee <flan_squee@openbsd.org>"' \
915 > $testroot/wt/.got/got.conf
917 echo "modified alpha" > $testroot/wt/alpha
918 (cd $testroot/wt && got commit -m 'test gotconfig author' > /dev/null)
919 ret=$?
920 if [ $ret -ne 0 ]; then
921 test_done "$testroot" "$ret"
922 return 1
923 fi
925 (cd $testroot/repo && got log -l1 | grep ^from: > $testroot/stdout)
926 ret=$?
927 if [ $ret -ne 0 ]; then
928 test_done "$testroot" "$ret"
929 return 1
930 fi
932 echo "from: Flan Squee <flan_squee@openbsd.org>" \
933 > $testroot/stdout.expected
934 cmp -s $testroot/stdout.expected $testroot/stdout
935 ret=$?
936 if [ $ret -ne 0 ]; then
937 diff -u $testroot/stdout.expected $testroot/stdout
938 fi
939 test_done "$testroot" "$ret"
942 test_commit_gitconfig_author() {
943 local testroot=`test_init commit_gitconfig_author`
945 got checkout $testroot/repo $testroot/wt > /dev/null
946 ret=$?
947 if [ $ret -ne 0 ]; then
948 test_done "$testroot" "$ret"
949 return 1
950 fi
952 (cd $testroot/repo && git config user.name 'Flan Luck')
953 (cd $testroot/repo && git config user.email 'flan_luck@openbsd.org')
955 echo "modified alpha" > $testroot/wt/alpha
957 # unset in a subshell to avoid affecting our environment
958 (unset GOT_IGNORE_GITCONFIG && cd $testroot/wt && \
959 got commit -m 'test gitconfig author' > /dev/null)
960 ret=$?
961 if [ $ret -ne 0 ]; then
962 test_done "$testroot" "$ret"
963 return 1
964 fi
966 (cd $testroot/repo && got log -l1 | grep ^from: > $testroot/stdout)
967 ret=$?
968 if [ $ret -ne 0 ]; then
969 test_done "$testroot" "$ret"
970 return 1
971 fi
973 echo "from: Flan Luck <flan_luck@openbsd.org>" \
974 > $testroot/stdout.expected
975 cmp -s $testroot/stdout.expected $testroot/stdout
976 ret=$?
977 if [ $ret -ne 0 ]; then
978 diff -u $testroot/stdout.expected $testroot/stdout
979 test_done "$testroot" "$ret"
980 return 1
981 fi
983 # retry with spaces in the git config
984 ed -s "$testroot/repo/.git/config" <<EOF
985 /^\[user/ a
986 # it's me!
988 ,s/ / /g
989 wq
990 EOF
991 echo "modified again" > $testroot/wt/alpha
993 # unset in a subshell to avoid affecting our environment
994 (unset GOT_IGNORE_GITCONFIG && cd "$testroot/wt" && \
995 got commit -m 'test gitconfig author again' \
996 >/dev/null 2>$testroot/stderr)
997 ret=$?
998 if [ $ret -ne 0 ]; then
999 test_done "$testroot" "$ret"
1000 return 1
1003 # shouldn't have triggered any parsing error
1004 echo -n > $testroot/stderr.expected
1005 cmp -s $testroot/stderr.expected $testroot/stderr
1006 ret=$?
1007 if [ $ret -ne 0 ]; then
1008 diff -u $testroot/stderr.expected $testroot/stderr
1009 test_done "$testroot" "$ret"
1010 return 1
1013 (cd "$testroot/repo" && got log -l1 | grep ^from: > $testroot/stdout)
1014 ret=$?
1015 if [ $ret -ne 0 ]; then
1016 test_done "$testroot" "$ret"
1017 return 1
1020 echo "from: Flan Luck <flan_luck@openbsd.org>" \
1021 > $testroot/stdout.expected
1022 cmp -s $testroot/stdout.expected $testroot/stdout
1023 ret=$?
1024 if [ $ret -ne 0 ]; then
1025 diff -u $testroot/stdout.expected $testroot/stdout
1027 test_done "$testroot" "$ret"
1030 test_commit_xbit_change() {
1031 local testroot=`test_init commit_xbit_change`
1033 got checkout $testroot/repo $testroot/wt > /dev/null
1034 ret=$?
1035 if [ $ret -ne 0 ]; then
1036 test_done "$testroot" "$ret"
1037 return 1
1040 chmod +x $testroot/wt/alpha
1042 echo 'm alpha' > $testroot/stdout.expected
1043 (cd $testroot/wt && got status > $testroot/stdout)
1045 cmp -s $testroot/stdout.expected $testroot/stdout
1046 ret=$?
1047 if [ $ret -ne 0 ]; then
1048 diff -u $testroot/stdout.expected $testroot/stdout
1049 test_done "$testroot" "$ret"
1050 return 1
1053 (cd $testroot/wt && got commit -mx > $testroot/stdout)
1054 ret=$?
1055 if [ $ret -ne 0 ]; then
1056 echo "got commit failed unexpectedly"
1057 test_done "$testroot" "$ret"
1058 return 1
1061 local commit_id=`git_show_head $testroot/repo`
1062 echo 'm alpha' > $testroot/stdout.expected
1063 echo "Created commit $commit_id" >> $testroot/stdout.expected
1064 cmp -s $testroot/stdout.expected $testroot/stdout
1065 ret=$?
1066 if [ $ret -ne 0 ]; then
1067 diff -u $testroot/stdout.expected $testroot/stdout
1068 test_done "$testroot" "$ret"
1069 return 1
1072 (cd $testroot/wt && got status > $testroot/stdout)
1074 echo -n > $testroot/stdout.expected
1075 cmp -s $testroot/stdout.expected $testroot/stdout
1076 ret=$?
1077 if [ $ret -ne 0 ]; then
1078 diff -u $testroot/stdout.expected $testroot/stdout
1079 test_done "$testroot" "$ret"
1080 return 1
1083 chmod -x $testroot/wt/alpha
1085 echo 'm alpha' > $testroot/stdout.expected
1086 (cd $testroot/wt && got status > $testroot/stdout)
1088 cmp -s $testroot/stdout.expected $testroot/stdout
1089 ret=$?
1090 if [ $ret -ne 0 ]; then
1091 diff -u $testroot/stdout.expected $testroot/stdout
1092 test_done "$testroot" "$ret"
1093 return 1
1096 (cd $testroot/wt && got commit -mx > $testroot/stdout)
1097 ret=$?
1098 if [ $ret -ne 0 ]; then
1099 echo "got commit failed unexpectedly"
1100 test_done "$testroot" "$ret"
1101 return 1
1104 local commit_id=`git_show_head $testroot/repo`
1105 echo 'm alpha' > $testroot/stdout.expected
1106 echo "Created commit $commit_id" >> $testroot/stdout.expected
1107 cmp -s $testroot/stdout.expected $testroot/stdout
1108 ret=$?
1109 if [ $ret -ne 0 ]; then
1110 diff -u $testroot/stdout.expected $testroot/stdout
1111 test_done "$testroot" "$ret"
1112 return 1
1115 chmod +x $testroot/wt/alpha
1117 echo 'm alpha' > $testroot/stdout.expected
1118 (cd $testroot/wt && got status > $testroot/stdout)
1120 cmp -s $testroot/stdout.expected $testroot/stdout
1121 ret=$?
1122 if [ $ret -ne 0 ]; then
1123 diff -u $testroot/stdout.expected $testroot/stdout
1125 test_done "$testroot" "$ret"
1128 commit_check_mode() {
1129 local mode="$1"
1130 local expected_mode="$2"
1132 chmod 644 $testroot/wt/alpha
1133 echo a >> $testroot/wt/alpha
1134 chmod $mode $testroot/wt/alpha
1136 (cd $testroot/wt && got commit -mm > $testroot/stdout)
1137 ret=$?
1138 if [ $ret -ne 0 ]; then
1139 echo "got commit failed unexpectedly"
1140 test_done "$testroot" "$ret"
1141 return 1
1144 local commit_id=`git_show_head $testroot/repo`
1145 echo 'M alpha' > $testroot/stdout.expected
1146 echo "Created commit $commit_id" >> $testroot/stdout.expected
1147 cmp -s $testroot/stdout.expected $testroot/stdout
1148 ret=$?
1149 if [ $ret -ne 0 ]; then
1150 diff -u $testroot/stdout.expected $testroot/stdout
1151 test_done "$testroot" "$ret"
1152 return 1
1155 local tree_id=$(got cat -r $testroot/repo $commit_id | \
1156 grep ^tree | cut -d' ' -f2)
1157 local alpha_id=$(got cat -r $testroot/repo $tree_id | \
1158 grep 'alpha$' | cut -d' ' -f1)
1159 echo "$alpha_id $expected_mode alpha" > $testroot/stdout.expected
1160 got cat -r $testroot/repo $tree_id | grep 'alpha$' > $testroot/stdout
1161 cmp -s $testroot/stdout.expected $testroot/stdout
1162 ret=$?
1163 if [ $ret -ne 0 ]; then
1164 diff -u $testroot/stdout.expected $testroot/stdout
1166 return $ret
1169 test_commit_normalizes_filemodes() {
1170 local testroot=`test_init commit_normalizes_filemodes`
1172 got checkout $testroot/repo $testroot/wt > /dev/null
1173 ret=$?
1174 if [ $ret -ne 0 ]; then
1175 test_done "$testroot" "$ret"
1176 return 1
1179 modes="600 400 460 640 440 660 444 666"
1180 for m in $modes; do
1181 commit_check_mode "$m" "0100644"
1182 ret=$?
1183 if [ $ret -ne 0 ]; then
1184 break
1186 done
1187 if [ $ret -ne 0 ]; then
1188 test_done "$testroot" "$ret"
1189 return 1
1191 modes="700 500 570 750 550 770 555 777"
1192 for m in $modes; do
1193 commit_check_mode "$m" "0100755"
1194 ret=$?
1195 if [ $ret -ne 0 ]; then
1196 break
1198 done
1199 if [ $ret -ne 0 ]; then
1200 test_done "$testroot" "$ret"
1201 return 1
1203 test_done "$testroot" "$ret"
1206 test_commit_with_unrelated_submodule() {
1207 local testroot=`test_init commit_with_unrelated_submodule`
1209 make_single_file_repo $testroot/repo2 foo
1211 (cd $testroot/repo && git -c protocol.file.allow=always \
1212 submodule -q add ../repo2)
1213 (cd $testroot/repo && git commit -q -m 'adding submodule')
1215 got checkout $testroot/repo $testroot/wt > /dev/null
1216 ret=$?
1217 if [ $ret -ne 0 ]; then
1218 echo "checkout failed unexpectedly" >&2
1219 test_done "$testroot" "$ret"
1220 return 1
1223 echo "modified alpha" > $testroot/wt/alpha
1225 echo "" > $testroot/stdout.expected
1227 (cd $testroot/wt && got commit -m 'modify alpha' > $testroot/stdout)
1228 ret=$?
1229 if [ $ret -ne 0 ]; then
1230 echo "commit failed unexpectedly" >&2
1231 test_done "$testroot" "$ret"
1232 return 1
1235 local head_rev=`git_show_head $testroot/repo`
1236 echo "M alpha" > $testroot/stdout.expected
1237 echo "Created commit $head_rev" >> $testroot/stdout.expected
1239 cmp -s $testroot/stdout.expected $testroot/stdout
1240 ret=$?
1241 if [ $ret -ne 0 ]; then
1242 diff -u $testroot/stdout.expected $testroot/stdout
1244 test_done "$testroot" "$ret"
1247 check_symlinks() {
1248 local wtpath="$1"
1249 if ! [ -h $wtpath/alpha.link ]; then
1250 echo "alpha.link is not a symlink"
1251 return 1
1254 readlink $wtpath/alpha.link > $testroot/stdout
1255 echo "alpha" > $testroot/stdout.expected
1256 cmp -s $testroot/stdout.expected $testroot/stdout
1257 ret=$?
1258 if [ $ret -ne 0 ]; then
1259 diff -u $testroot/stdout.expected $testroot/stdout
1260 return 1
1263 if ! [ -h $wtpath/epsilon.link ]; then
1264 echo "epsilon.link is not a symlink"
1265 return 1
1268 readlink $wtpath/epsilon.link > $testroot/stdout
1269 echo "epsilon" > $testroot/stdout.expected
1270 cmp -s $testroot/stdout.expected $testroot/stdout
1271 ret=$?
1272 if [ $ret -ne 0 ]; then
1273 diff -u $testroot/stdout.expected $testroot/stdout
1274 return 1
1277 if [ -h $wtpath/passwd.link ]; then
1278 echo -n "passwd.link is a symlink and points outside of work tree: " >&2
1279 readlink $wtpath/passwd.link >&2
1280 return 1
1283 echo -n "/etc/passwd" > $testroot/content.expected
1284 cp $wtpath/passwd.link $testroot/content
1285 ret=$?
1286 if [ $ret -ne 0 ]; then
1287 echo "cp command failed unexpectedly" >&2
1288 return 1
1291 cmp -s $testroot/content.expected $testroot/content
1292 ret=$?
1293 if [ $ret -ne 0 ]; then
1294 diff -u $testroot/content.expected $testroot/content
1295 return 1
1298 readlink $wtpath/epsilon/beta.link > $testroot/stdout
1299 echo "../beta" > $testroot/stdout.expected
1300 cmp -s $testroot/stdout.expected $testroot/stdout
1301 ret=$?
1302 if [ $ret -ne 0 ]; then
1303 diff -u $testroot/stdout.expected $testroot/stdout
1304 return 1
1307 readlink $wtpath/nonexistent.link > $testroot/stdout
1308 echo "nonexistent" > $testroot/stdout.expected
1309 cmp -s $testroot/stdout.expected $testroot/stdout
1310 ret=$?
1311 if [ $ret -ne 0 ]; then
1312 diff -u $testroot/stdout.expected $testroot/stdout
1313 return 1
1316 return 0
1319 test_commit_symlink() {
1320 local testroot=`test_init commit_symlink`
1322 got checkout $testroot/repo $testroot/wt > /dev/null
1323 ret=$?
1324 if [ $ret -ne 0 ]; then
1325 test_done "$testroot" "$ret"
1326 return 1
1329 (cd $testroot/wt && ln -s alpha alpha.link)
1330 (cd $testroot/wt && ln -s epsilon epsilon.link)
1331 (cd $testroot/wt && ln -s /etc/passwd passwd.link)
1332 (cd $testroot/wt && ln -s ../beta epsilon/beta.link)
1333 (cd $testroot/wt && ln -s nonexistent nonexistent.link)
1334 (cd $testroot/wt && got add alpha.link epsilon.link passwd.link \
1335 epsilon/beta.link nonexistent.link > /dev/null)
1337 (cd $testroot/wt && got commit -m 'test commit_symlink' \
1338 > $testroot/stdout 2> $testroot/stderr)
1339 ret=$?
1340 if [ $ret -eq 0 ]; then
1341 echo "got commit succeeded unexpectedly" >&2
1342 test_done "$testroot" "$ret"
1343 return 1
1345 echo -n "got: $testroot/wt/passwd.link: " > $testroot/stderr.expected
1346 echo "symbolic link points outside of paths under version control" \
1347 >> $testroot/stderr.expected
1348 cmp -s $testroot/stderr.expected $testroot/stderr
1349 ret=$?
1350 if [ $ret -ne 0 ]; then
1351 diff -u $testroot/stderr.expected $testroot/stderr
1352 test_done "$testroot" "$ret"
1353 return 1
1356 (cd $testroot/wt && got commit -S -m 'test commit_symlink' \
1357 > $testroot/stdout)
1359 local head_rev=`git_show_head $testroot/repo`
1360 echo "A alpha.link" > $testroot/stdout.expected
1361 echo "A epsilon.link" >> $testroot/stdout.expected
1362 echo "A nonexistent.link" >> $testroot/stdout.expected
1363 echo "A passwd.link" >> $testroot/stdout.expected
1364 echo "A epsilon/beta.link" >> $testroot/stdout.expected
1365 echo "Created commit $head_rev" >> $testroot/stdout.expected
1367 cmp -s $testroot/stdout.expected $testroot/stdout
1368 ret=$?
1369 if [ $ret -ne 0 ]; then
1370 diff -u $testroot/stdout.expected $testroot/stdout
1371 test_done "$testroot" "$ret"
1372 return 1
1375 # verify created in-repository tree
1376 got checkout $testroot/repo $testroot/wt2 > /dev/null
1377 ret=$?
1378 if [ $ret -ne 0 ]; then
1379 test_done "$testroot" "$ret"
1380 return 1
1382 check_symlinks $testroot/wt2
1383 ret=$?
1384 if [ $ret -ne 0 ]; then
1385 test_done "$testroot" "$ret"
1386 return 1
1389 if ! [ -h $testroot/wt/passwd.link ]; then
1390 echo 'passwd.link is not a symlink' >&2
1391 test_done "$testroot" 1
1392 return 1
1395 # 'got update' should reinstall passwd.link as a regular file
1396 (cd $testroot/wt && got update > /dev/null)
1397 check_symlinks $testroot/wt
1398 ret=$?
1399 if [ $ret -ne 0 ]; then
1400 test_done "$testroot" "$ret"
1401 return 1
1404 (cd $testroot/wt && ln -sf beta alpha.link)
1405 (cd $testroot/wt && rm epsilon.link && ln -s gamma epsilon.link)
1406 rm $testroot/wt/epsilon/beta.link
1407 echo "this is a regular file" > $testroot/wt/epsilon/beta.link
1408 (cd $testroot/wt && ln -sf .got/bar dotgotbar.link)
1409 (cd $testroot/wt && got add dotgotbar.link > /dev/null)
1410 (cd $testroot/wt && got rm nonexistent.link > /dev/null)
1411 (cd $testroot/wt && ln -sf gamma/delta zeta.link)
1412 (cd $testroot/wt && ln -sf alpha new.link)
1413 (cd $testroot/wt && got add new.link > /dev/null)
1415 (cd $testroot/wt && got commit -m 'test commit_symlink' \
1416 > $testroot/stdout 2> $testroot/stderr)
1417 ret=$?
1418 if [ $ret -eq 0 ]; then
1419 echo "got commit succeeded unexpectedly" >&2
1420 test_done "$testroot" "$ret"
1421 return 1
1423 echo -n "got: $testroot/wt/dotgotbar.link: " > $testroot/stderr.expected
1424 echo "symbolic link points outside of paths under version control" \
1425 >> $testroot/stderr.expected
1426 cmp -s $testroot/stderr.expected $testroot/stderr
1427 ret=$?
1428 if [ $ret -ne 0 ]; then
1429 diff -u $testroot/stderr.expected $testroot/stderr
1430 test_done "$testroot" "$ret"
1431 return 1
1434 (cd $testroot/wt && got commit -S -m 'test commit_symlink' \
1435 > $testroot/stdout)
1437 local head_rev=`git_show_head $testroot/repo`
1438 echo "A dotgotbar.link" > $testroot/stdout.expected
1439 echo "A new.link" >> $testroot/stdout.expected
1440 echo "M alpha.link" >> $testroot/stdout.expected
1441 echo "M epsilon/beta.link" >> $testroot/stdout.expected
1442 echo "M epsilon.link" >> $testroot/stdout.expected
1443 echo "D nonexistent.link" >> $testroot/stdout.expected
1444 echo "Created commit $head_rev" >> $testroot/stdout.expected
1446 cmp -s $testroot/stdout.expected $testroot/stdout
1447 ret=$?
1448 if [ $ret -ne 0 ]; then
1449 diff -u $testroot/stdout.expected $testroot/stdout
1450 test_done "$testroot" "$ret"
1451 return 1
1454 got tree -r $testroot/repo -c $head_rev -R > $testroot/stdout
1455 cat > $testroot/stdout.expected <<EOF
1456 alpha
1457 alpha.link@ -> beta
1458 beta
1459 dotgotbar.link@ -> .got/bar
1460 epsilon/
1461 epsilon/beta.link
1462 epsilon/zeta
1463 epsilon.link@ -> gamma
1464 gamma/
1465 gamma/delta
1466 new.link@ -> alpha
1467 passwd.link@ -> /etc/passwd
1468 EOF
1469 cmp -s $testroot/stdout.expected $testroot/stdout
1470 ret=$?
1471 if [ $ret -ne 0 ]; then
1472 diff -u $testroot/stdout.expected $testroot/stdout
1474 test_done "$testroot" "$ret"
1477 test_commit_fix_bad_symlink() {
1478 local testroot=`test_init commit_fix_bad_symlink`
1480 got checkout $testroot/repo $testroot/wt > /dev/null
1481 ret=$?
1482 if [ $ret -ne 0 ]; then
1483 echo "got checkout failed unexpectedly" >&2
1484 test_done "$testroot" "$ret"
1485 return 1
1488 (cd $testroot/wt && ln -s /etc/passwd passwd.link)
1489 (cd $testroot/wt && got add passwd.link > /dev/null)
1491 (cd $testroot/wt && got commit -S -m 'commit bad symlink' \
1492 > $testroot/stdout)
1494 if ! [ -h $testroot/wt/passwd.link ]; then
1495 echo 'passwd.link is not a symlink' >&2
1496 test_done "$testroot" 1
1497 return 1
1499 (cd $testroot/wt && got update >/dev/null)
1500 if [ -h $testroot/wt/passwd.link ]; then
1501 echo "passwd.link is a symlink but should be a regular file" >&2
1502 test_done "$testroot" "1"
1503 return 1
1506 # create another work tree which will contain the "bad" symlink
1507 got checkout $testroot/repo $testroot/wt2 > /dev/null
1508 ret=$?
1509 if [ $ret -ne 0 ]; then
1510 echo "got checkout failed unexpectedly" >&2
1511 test_done "$testroot" "$ret"
1512 return 1
1515 # change "bad" symlink back into a "good" symlink
1516 (cd $testroot/wt && rm passwd.link && ln -s alpha passwd.link)
1518 (cd $testroot/wt && got commit -m 'fix bad symlink' \
1519 > $testroot/stdout)
1521 local head_rev=`git_show_head $testroot/repo`
1522 echo "M passwd.link" > $testroot/stdout.expected
1523 echo "Created commit $head_rev" >> $testroot/stdout.expected
1525 cmp -s $testroot/stdout.expected $testroot/stdout
1526 ret=$?
1527 if [ $ret -ne 0 ]; then
1528 diff -u $testroot/stdout.expected $testroot/stdout
1529 test_done "$testroot" "$ret"
1530 return 1
1533 if ! [ -h $testroot/wt/passwd.link ]; then
1534 echo 'passwd.link is not a symlink' >&2
1535 test_done "$testroot" 1
1536 return 1
1539 readlink $testroot/wt/passwd.link > $testroot/stdout
1540 echo "alpha" > $testroot/stdout.expected
1541 cmp -s $testroot/stdout.expected $testroot/stdout
1542 ret=$?
1543 if [ $ret -ne 0 ]; then
1544 diff -u $testroot/stdout.expected $testroot/stdout
1545 return 1
1548 # Update the other work tree; the bad symlink should be fixed
1549 (cd $testroot/wt2 && got update > /dev/null)
1550 ret=$?
1551 if [ $ret -ne 0 ]; then
1552 echo "got checkout failed unexpectedly" >&2
1553 test_done "$testroot" "$ret"
1554 return 1
1557 if ! [ -h $testroot/wt2/passwd.link ]; then
1558 echo 'passwd.link is not a symlink' >&2
1559 test_done "$testroot" 1
1560 return 1
1563 readlink $testroot/wt2/passwd.link > $testroot/stdout
1564 echo "alpha" > $testroot/stdout.expected
1565 cmp -s $testroot/stdout.expected $testroot/stdout
1566 ret=$?
1567 if [ $ret -ne 0 ]; then
1568 diff -u $testroot/stdout.expected $testroot/stdout
1569 return 1
1572 test_done "$testroot" "0"
1575 test_commit_prepared_logmsg() {
1576 local testroot=`test_init commit_prepared_logmsg`
1578 got checkout $testroot/repo $testroot/wt > /dev/null
1579 ret=$?
1580 if [ $ret -ne 0 ]; then
1581 test_done "$testroot" "$ret"
1582 return 1
1585 echo "modified alpha" > $testroot/wt/alpha
1586 (cd $testroot/wt && got rm beta >/dev/null)
1587 echo "new file" > $testroot/wt/new
1588 (cd $testroot/wt && got add new >/dev/null)
1590 echo 'test commit_prepared_logmsg' > $testroot/logmsg
1592 # a no-op editor script
1593 > $testroot/editor.sh
1594 chmod +x $testroot/editor.sh
1596 (cd $testroot/wt && env VISUAL="$testroot/editor.sh" \
1597 got commit -F "$testroot/logmsg" > $testroot/stdout)
1599 local head_rev=`git_show_head $testroot/repo`
1600 echo "A new" > $testroot/stdout.expected
1601 echo "M alpha" >> $testroot/stdout.expected
1602 echo "D beta" >> $testroot/stdout.expected
1603 echo "Created commit $head_rev" >> $testroot/stdout.expected
1605 cmp -s $testroot/stdout.expected $testroot/stdout
1606 ret=$?
1607 if [ $ret -ne 0 ]; then
1608 diff -u $testroot/stdout.expected $testroot/stdout
1609 test_done "$testroot" "$ret"
1610 return 1
1613 local author_time=`git_show_author_time $testroot/repo`
1614 d=`date -u -r $author_time +"%a %b %e %X %Y UTC"`
1615 echo "-----------------------------------------------" > $testroot/stdout.expected
1616 echo "commit $head_rev (master)" >> $testroot/stdout.expected
1617 echo "from: $GOT_AUTHOR" >> $testroot/stdout.expected
1618 echo "date: $d" >> $testroot/stdout.expected
1619 echo " " >> $testroot/stdout.expected
1620 echo " test commit_prepared_logmsg" >> $testroot/stdout.expected
1621 echo " " >> $testroot/stdout.expected
1623 (cd $testroot/wt && got log -l 1 > $testroot/stdout)
1624 cmp -s $testroot/stdout.expected $testroot/stdout
1625 ret=$?
1626 if [ $ret -ne 0 ]; then
1627 diff -u $testroot/stdout.expected $testroot/stdout
1628 test_done "$testroot" "$ret"
1629 return 1
1632 echo "modified alpha again" > $testroot/wt/alpha
1634 echo 'test commit_prepared_logmsg non-interactive' \
1635 > $testroot/logmsg
1637 (cd $testroot/wt && got commit -N -F "$testroot/logmsg" \
1638 > $testroot/stdout)
1640 local head_rev=`git_show_head $testroot/repo`
1641 echo "M alpha" > $testroot/stdout.expected
1642 echo "Created commit $head_rev" >> $testroot/stdout.expected
1644 cmp -s $testroot/stdout.expected $testroot/stdout
1645 ret=$?
1646 if [ $ret -ne 0 ]; then
1647 diff -u $testroot/stdout.expected $testroot/stdout
1648 test_done "$testroot" "$ret"
1649 return 1
1652 local author_time=`git_show_author_time $testroot/repo`
1653 d=`date -u -r $author_time +"%a %b %e %X %Y UTC"`
1654 echo "-----------------------------------------------" \
1655 > $testroot/stdout.expected
1656 echo "commit $head_rev (master)" >> $testroot/stdout.expected
1657 echo "from: $GOT_AUTHOR" >> $testroot/stdout.expected
1658 echo "date: $d" >> $testroot/stdout.expected
1659 echo " " >> $testroot/stdout.expected
1660 echo " test commit_prepared_logmsg non-interactive" \
1661 >> $testroot/stdout.expected
1662 echo " " >> $testroot/stdout.expected
1664 (cd $testroot/wt && got log -l 1 > $testroot/stdout)
1665 cmp -s $testroot/stdout.expected $testroot/stdout
1666 ret=$?
1667 if [ $ret -ne 0 ]; then
1668 diff -u $testroot/stdout.expected $testroot/stdout
1670 test_done "$testroot" "$ret"
1673 test_commit_large_file() {
1674 local testroot=`test_init commit_large_file`
1676 got checkout $testroot/repo $testroot/wt > /dev/null
1677 ret=$?
1678 if [ $ret -ne 0 ]; then
1679 test_done "$testroot" "$ret"
1680 return 1
1683 dd status=none if=/dev/zero of=$testroot/wt/new bs=1M count=64
1684 (cd $testroot/wt && got add new >/dev/null)
1686 (cd $testroot/wt && got commit -m 'test commit_large_file' \
1687 > $testroot/stdout)
1689 local head_rev=`git_show_head $testroot/repo`
1690 echo "A new" > $testroot/stdout.expected
1691 echo "Created commit $head_rev" >> $testroot/stdout.expected
1693 cmp -s $testroot/stdout.expected $testroot/stdout
1694 ret=$?
1695 if [ $ret -ne 0 ]; then
1696 diff -u $testroot/stdout.expected $testroot/stdout
1697 test_done "$testroot" "$ret"
1698 return 1
1701 new_id=`get_blob_id $testroot/repo "" new`
1702 got cat -r $testroot/repo $new_id > $testroot/new
1703 ret=$?
1704 if [ $ret -ne 0 ]; then
1705 echo "commit failed unexpectedly" >&2
1706 test_done "$testroot" "1"
1707 return 1
1710 cmp -s $testroot/new $testroot/wt/new
1711 ret=$?
1712 if [ $ret -ne 0 ]; then
1713 diff -u $testroot/new $testroot/wt/new
1715 test_done "$testroot" "$ret"
1720 test_commit_gitignore() {
1721 local testroot=`test_init commit_gitignores`
1723 got checkout $testroot/repo $testroot/wt > /dev/null
1724 ret=$?
1725 if [ $ret -ne 0 ]; then
1726 test_done "$testroot" "$ret"
1727 return 1
1730 mkdir -p $testroot/wt/tree1/foo
1731 mkdir -p $testroot/wt/tree2/foo
1732 echo "tree1/**" > $testroot/wt/.gitignore
1733 echo "tree2/**" >> $testroot/wt/.gitignore
1734 echo -n > $testroot/wt/tree1/bar
1735 echo -n > $testroot/wt/tree1/foo/baz
1736 echo -n > $testroot/wt/tree2/bar
1737 echo -n > $testroot/wt/tree2/foo/baz
1738 echo -n > $testroot/wt/epsilon/zeta1
1739 echo -n > $testroot/wt/epsilon/zeta2
1741 (cd $testroot/wt && got add -I -R tree1 > /dev/null)
1742 (cd $testroot/wt && got add -I tree2/foo/baz > /dev/null)
1743 (cd $testroot/wt && got commit -m "gitignore add" > /dev/null)
1744 (cd $testroot/wt && got log -P -l 1 | egrep '^ .' > $testroot/stdout)
1746 echo ' gitignore add' > $testroot/stdout.expected
1747 echo ' A tree1/bar' >> $testroot/stdout.expected
1748 echo ' A tree1/foo/baz' >> $testroot/stdout.expected
1749 echo ' A tree2/foo/baz' >> $testroot/stdout.expected
1751 cmp -s $testroot/stdout.expected $testroot/stdout
1752 ret=$?
1753 if [ $ret -ne 0 ]; then
1754 diff -u $testroot/stdout.expected $testroot/stdout
1755 test_done "$testroot" "$ret"
1756 return 1
1759 echo touch > $testroot/wt/tree1/bar
1760 echo touch > $testroot/wt/tree1/foo/baz
1761 echo touch > $testroot/wt/epsilon/zeta1
1763 (cd $testroot/wt && got commit -m "gitignore change" > /dev/null)
1764 (cd $testroot/wt && got log -P -l 1 | egrep '^ .' > $testroot/stdout)
1766 echo ' gitignore change' > $testroot/stdout.expected
1767 echo ' M tree1/bar' >> $testroot/stdout.expected
1768 echo ' M tree1/foo/baz' >> $testroot/stdout.expected
1770 cmp -s $testroot/stdout.expected $testroot/stdout
1771 ret=$?
1772 if [ $ret -ne 0 ]; then
1773 diff -u $testroot/stdout.expected $testroot/stdout
1774 test_done "$testroot" "$ret"
1775 return 1
1778 test_done "$testroot" "$ret"
1781 test_commit_bad_author() {
1782 local testroot=`test_init commit_bad_author`
1784 got checkout $testroot/repo $testroot/wt > /dev/null
1785 ret=$?
1786 if [ $ret -ne 0 ]; then
1787 test_done "$testroot" $ret
1788 return 1
1791 echo "modified alpha" > $testroot/wt/alpha
1793 (cd $testroot/wt && got commit \
1794 -A "${GIT_AUTHOR_NAME}<${GIT_AUTHOR_EMAIL}>" -m 'edit alpha') \
1795 > /dev/null 2> $testroot/stderr
1796 ret=$?
1797 if [ $ret -eq 0 ]; then
1798 test_done "$testroot" 1
1799 return 1
1802 echo -n "got: ${GIT_AUTHOR_NAME}<${GIT_AUTHOR_EMAIL}>: " \
1803 > $testroot/stderr.expected
1804 echo -n 'space between author name and email required: ' \
1805 >> $testroot/stderr.expected
1806 echo 'commit author formatting would make Git unhappy' \
1807 >> $testroot/stderr.expected
1808 cmp -s $testroot/stderr.expected $testroot/stderr
1809 ret=$?
1810 if [ $ret -ne 0 ]; then
1811 diff -u $testroot/stderr.expected $testroot/stderr
1812 test_done "$testroot" $ret
1813 return 1
1816 test_done "$testroot" 0
1819 test_commit_logmsg_ref() {
1820 local testroot=`test_init commit_logmsg_ref`
1822 got checkout $testroot/repo $testroot/wt > /dev/null
1823 ret=$?
1824 if [ $ret -ne 0 ]; then
1825 test_done "$testroot" "$ret"
1826 return 1
1829 (cd $testroot/repo && git checkout -q -b newbranch)
1831 local bo_logmsg_prefix="log message of backed-out commit"
1832 local cy_logmsg_prefix="log message of cherrypicked commit"
1833 local branch_rev_logmsg="changes on newbranch to cherrypick"
1834 local branch_rev2_logmsg="modified zeta on newbranch to cherrypick"
1836 echo "modified delta on branch" > $testroot/repo/gamma/delta
1837 echo "modified alpha on branch" > $testroot/repo/alpha
1838 (cd $testroot/repo && git rm -q beta)
1839 echo "new file on branch" > $testroot/repo/epsilon/new
1840 (cd $testroot/repo && git add epsilon/new)
1842 git_commit $testroot/repo -m "$branch_rev_logmsg"
1843 local branch_rev=`git_show_head $testroot/repo`
1845 echo "modified zeta on branch" > $testroot/repo/epsilon/zeta
1847 git_commit $testroot/repo -m "$branch_rev2_logmsg"
1848 local branch_rev2=`git_show_head $testroot/repo`
1850 (cd $testroot/wt && got cherrypick $branch_rev > /dev/null)
1851 (cd $testroot/wt && got cherrypick $branch_rev2 > /dev/null)
1853 cat > $testroot/editor.sh <<EOF
1854 #!/bin/sh
1855 ed -s "\$1" <<-EOF
1856 ,s/# l/l/
1858 EOF
1859 EOF
1860 chmod +x $testroot/editor.sh
1862 (cd $testroot/wt && env VISUAL="$testroot/editor.sh" \
1863 got commit > /dev/null)
1864 ret=$?
1865 if [ $ret -ne 0 ]; then
1866 echo "'got commit' failed unexpectedly" >&2
1867 test_done "$testroot" "1"
1868 return 1
1871 # check that multiple cherrypicked log messages populate the editor
1872 local first=`printf '%s\n%s' $branch_rev $branch_rev2 | sort | head -1`
1873 local second=`printf '%s\n%s' $branch_rev $branch_rev2 | sort | tail -1`
1875 if [ $branch_rev = $first ]; then
1876 local first_msg=$branch_rev_logmsg
1877 local second_msg=$branch_rev2_logmsg
1878 else
1879 local first_msg=$branch_rev2_logmsg
1880 local second_msg=$branch_rev_logmsg
1883 echo " $cy_logmsg_prefix $first:" > $testroot/stdout.expected
1884 echo " $first_msg" >> $testroot/stdout.expected
1885 echo " " >> $testroot/stdout.expected
1886 echo " $cy_logmsg_prefix $second:" >> $testroot/stdout.expected
1887 echo " $second_msg" >> $testroot/stdout.expected
1888 echo " " >> $testroot/stdout.expected
1890 (cd $testroot/wt && got log -l2 | \
1891 grep -A2 'log message' | sed '/^--/d' > $testroot/stdout)
1893 cmp -s $testroot/stdout.expected $testroot/stdout
1894 ret=$?
1895 if [ $ret -ne 0 ]; then
1896 diff -u $testroot/stdout.expected $testroot/stdout
1897 test_done "$testroot" "$ret"
1898 return 1
1901 # check that only the relevant log message populates the editor
1902 # when the changes from one of two backout commits are reverted
1903 got checkout $testroot/repo $testroot/wt2 > /dev/null
1904 ret=$?
1905 if [ $ret -ne 0 ]; then
1906 test_done "$testroot" "$ret"
1907 return 1
1910 (cd $testroot/wt2 && got backout $branch_rev > /dev/null)
1911 (cd $testroot/wt2 && got backout $branch_rev2 > /dev/null)
1912 (cd $testroot/wt2 && got revert epsilon/zeta > /dev/null)
1914 (cd $testroot/wt2 && env VISUAL="$testroot/editor.sh" \
1915 got commit > /dev/null)
1916 ret=$?
1917 if [ $ret -ne 0 ]; then
1918 echo "'got commit' failed unexpectedly" >&2
1919 test_done "$testroot" "1"
1920 return 1
1923 echo " $bo_logmsg_prefix $branch_rev:" > $testroot/stdout.expected
1924 echo " $branch_rev_logmsg" >> $testroot/stdout.expected
1925 echo " " >> $testroot/stdout.expected
1927 (cd $testroot/wt2 && got log -l1 | \
1928 grep -A2 'log message' > $testroot/stdout)
1930 cmp -s $testroot/stdout.expected $testroot/stdout
1931 ret=$?
1932 if [ $ret -ne 0 ]; then
1933 diff -u $testroot/stdout.expected $testroot/stdout
1934 test_done "$testroot" "$ret"
1935 return 1
1938 # check that a cherrypicked log message is still
1939 # used when its changes are only partially reverted
1940 branch_rev_logmsg="changes to cherrypick and partially revert"
1942 echo "newline in alpha" >> $testroot/repo/alpha
1943 echo "modified epsilon/zeta on branch" > $testroot/repo/epsilon/zeta
1945 git_commit $testroot/repo -m "$branch_rev_logmsg"
1946 branch_rev=`git_show_head $testroot/repo`
1948 (cd $testroot/wt && got cherrypick $branch_rev > /dev/null)
1949 (cd $testroot/wt && got revert alpha > /dev/null)
1951 (cd $testroot/wt && env VISUAL="$testroot/editor.sh" \
1952 got commit > /dev/null)
1953 ret=$?
1954 if [ $ret -ne 0 ]; then
1955 echo "'got commit' failed unexpectedly" >&2
1956 test_done "$testroot" "1"
1957 return 1
1960 echo " $cy_logmsg_prefix $branch_rev:" > $testroot/stdout.expected
1961 echo " $branch_rev_logmsg" >> $testroot/stdout.expected
1962 echo " " >> $testroot/stdout.expected
1964 (cd $testroot/wt && got log -l1 | \
1965 grep -A2 'log message' > $testroot/stdout)
1967 cmp -s $testroot/stdout.expected $testroot/stdout
1968 ret=$?
1969 if [ $ret -ne 0 ]; then
1970 diff -u $testroot/stdout.expected $testroot/stdout
1971 test_done "$testroot" "$ret"
1972 return 1
1975 # check we don't use and consequently delete the logmsg ref of a
1976 # cherrypicked commit when omitting its changed path from the commit
1977 branch_rev_logmsg="changes to cherrypick but omit from the commit"
1979 echo "changed delta" >> $testroot/repo/gamma/delta
1981 git_commit $testroot/repo -m "$branch_rev_logmsg"
1982 local author_time=`git_show_author_time $testroot/repo`
1983 local d=`date -u -r $author_time +"%a %b %e %X %Y UTC"`
1984 branch_rev=`git_show_head $testroot/repo`
1986 (cd $testroot/wt && got update > /dev/null)
1987 ret=$?
1988 if [ $ret -ne 0 ]; then
1989 echo "got update failed unexpectedly" >&2
1990 test_done "$testroot" "$ret"
1991 return 1
1994 (cd $testroot/wt && got cherrypick $branch_rev > /dev/null)
1996 echo "changed alpha" >> $testroot/wt/alpha
1998 (cd $testroot/wt && got commit -m \
1999 "don't commit cy change to gamma/delta" alpha > /dev/null)
2000 ret=$?
2001 if [ $ret -ne 0 ]; then
2002 echo "'got commit' failed unexpectedly" >&2
2003 test_done "$testroot" "1"
2004 return 1
2007 # confirm logmsg ref was not deleted with got cherrypick -l
2008 echo "-----------------------------------------------" \
2009 > $testroot/stdout.expected
2010 echo "cherrypick $branch_rev (newbranch)" >> $testroot/stdout.expected
2011 echo "from: $GOT_AUTHOR" >> $testroot/stdout.expected
2012 echo "date: $d" >> $testroot/stdout.expected
2013 echo " " >> $testroot/stdout.expected
2014 echo " $branch_rev_logmsg" >> $testroot/stdout.expected
2015 echo " " >> $testroot/stdout.expected
2016 echo " M gamma/delta" >> $testroot/stdout.expected
2017 echo >> $testroot/stdout.expected
2019 (cd $testroot/wt && got cherrypick -l > $testroot/stdout)
2021 cmp -s $testroot/stdout.expected $testroot/stdout
2022 ret=$?
2023 if [ $ret -ne 0 ]; then
2024 diff -u $testroot/stdout.expected $testroot/stdout
2025 test_done "$testroot" "$ret"
2026 return 1
2029 # confirm a previously unused logmsg ref is picked up
2030 # when an affected path is actually committed
2031 (cd $testroot/wt && env VISUAL="$testroot/editor.sh" \
2032 got commit > /dev/null)
2033 ret=$?
2034 if [ $ret -ne 0 ]; then
2035 echo "'got commit' failed unexpectedly" >&2
2036 test_done "$testroot" "1"
2037 return 1
2040 echo " $cy_logmsg_prefix $branch_rev:" > $testroot/stdout.expected
2041 echo " $branch_rev_logmsg" >> $testroot/stdout.expected
2042 echo " " >> $testroot/stdout.expected
2044 (cd $testroot/wt && got log -l1 | \
2045 grep -A2 'log message' > $testroot/stdout)
2047 cmp -s $testroot/stdout.expected $testroot/stdout
2048 ret=$?
2049 if [ $ret -ne 0 ]; then
2050 diff -u $testroot/stdout.expected $testroot/stdout
2051 test_done "$testroot" "$ret"
2052 return 1
2055 # make sure we are not littering work trees
2056 # by leaving temp got-logmsg-* files behind
2057 echo -n > $testroot/stdout.expected
2058 (cd $testroot/wt && got status > $testroot/stdout)
2060 cmp -s $testroot/stdout.expected $testroot/stdout
2061 ret=$?
2062 if [ $ret -ne 0 ]; then
2063 echo "$testroot/wt is not clean"
2064 diff -u $testroot/stdout.expected $testroot/stdout
2065 test_done "$testroot" "$ret"
2066 return 1
2069 (cd $testroot/wt2 && got status > $testroot/stdout)
2071 cmp -s $testroot/stdout.expected $testroot/stdout
2072 ret=$?
2073 if [ $ret -ne 0 ]; then
2074 echo "$testroot/repo is not clean"
2075 diff -u $testroot/stdout.expected $testroot/stdout
2077 test_done "$testroot" "$ret"
2080 test_commit_from_different_worktrees() {
2081 local testroot=$(test_init commit_from_different_worktrees)
2083 got checkout $testroot/repo $testroot/wt > /dev/null
2084 ret=$?
2085 if [ $ret -ne 0 ]; then
2086 test_done "$testroot" "$ret"
2087 return 1
2090 got checkout $testroot/repo $testroot/wt2 > /dev/null
2091 ret=$?
2092 if [ $ret -ne 0 ]; then
2093 test_done "$testroot" "$ret"
2094 return 1
2097 echo "new file" > $testroot/wt2/new
2098 (cd $testroot/wt2 && got add new >/dev/null)
2099 (cd $testroot/wt2 && got commit -m 'add new file from wt2' > \
2100 $testroot/stdout)
2101 local wt2_head_id=$(git_show_head $testroot/repo)
2103 echo "modified alpha" > $testroot/wt/alpha
2104 (cd $testroot/wt && got commit -m 'mod alpha in wt' > $testroot/stdout)
2105 local wt1_parent_id=$(git_show_parent_commit $testroot/repo)
2107 if [ $wt2_head_id != $wt1_parent_id ]; then
2108 echo "commit lost from different work tree" >&2
2109 test_done "$testroot" "1"
2112 test_done "$testroot" "0"
2115 test_parseargs "$@"
2116 run_test test_commit_basic
2117 run_test test_commit_new_subdir
2118 run_test test_commit_subdir
2119 run_test test_commit_single_file
2120 run_test test_commit_out_of_date
2121 run_test test_commit_added_subdirs
2122 run_test test_commit_deleted_subdirs
2123 run_test test_commit_rejects_conflicted_file
2124 run_test test_commit_single_file_multiple
2125 run_test test_commit_added_and_modified_in_same_dir
2126 run_test test_commit_path_prefix
2127 run_test test_commit_dir_path
2128 run_test test_commit_selected_paths
2129 run_test test_commit_outside_refs_heads
2130 run_test test_commit_no_email
2131 run_test test_commit_tree_entry_sorting
2132 run_test test_commit_cmdline_author
2133 run_test test_commit_gotconfig_author
2134 run_test test_commit_gotconfig_worktree_author
2135 run_test test_commit_gitconfig_author
2136 run_test test_commit_xbit_change
2137 run_test test_commit_normalizes_filemodes
2138 run_test test_commit_with_unrelated_submodule
2139 run_test test_commit_symlink
2140 run_test test_commit_fix_bad_symlink
2141 run_test test_commit_prepared_logmsg
2142 run_test test_commit_large_file
2143 run_test test_commit_gitignore
2144 run_test test_commit_bad_author
2145 run_test test_commit_logmsg_ref
2146 run_test test_commit_from_different_worktrees